//
//  Action.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Cocoa/Cocoa.h>


@interface Action : NSObject {

	NSString* name;			// name of the action

	NSImage* image;		// image the represents the action
	NSPoint positionIconWheel;  // positon on the icon wheel
	
	SEL process;			// what do we do when this item is bought?
	id param1;			// first param for processing
	
	BOOL draggable;		// can the item be dragged?
}

-(void)setName:(NSString*)newName;
-(NSString*)name;


-(void)setImage:(NSImage*)newImage;
-(NSImage*)image;

- (void)setPositionIconWheel:(NSPoint)newPosition;
- (NSPoint)positionIconWheel;

- (SEL)process;
- (void)setProcess:(SEL)newProcess;

- (void)setParam1:(id)newParam;
- (id)param1;

- (void)setDraggable:(BOOL)flag;
- (BOOL)draggable;

@end
