//
//  Button.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>

enum { TYPE_TEXT, TYPE_IMAGE, TYPE_BLANK };

@interface Button : NSObject {
	NSRect rect;
	NSString* text;
	NSImage* imageOn;
	NSImage* imageOff;
	int buttonID;
	BOOL selected;
	int type;
	BOOL enabled;
	BOOL inside;	// is mouse inside this button
	
	id  data;		// additional data relevent to the button
	SEL method;			// method to be called when the button is clicked
	
	int numParams;  // number of parameters that the button method has
}

+ (Button*)initWithID:(int)newID position:(NSRect)newRect text:(NSString*)newText;

- (void)setImageOn:(NSImage*)newOnImage imageOff:(NSImage*)newOffImage;

- (NSImage*)imageOn;

- (void)setButtonID:(int)newID;
- (int)buttonID;

- (void)setRect:(NSRect)newRect;
- (NSRect)rect;

- (void)setText:(NSString*)newText;
- (NSString*)text;

- (void)setSelected:(BOOL)newSelected;
- (BOOL)selected;

- (void)setEnabled:(BOOL)flag;
- (BOOL)enabled;

- (void)setInside:(BOOL)flag;
- (BOOL)inside;

- (void)setData:(id)newData;
- (id)data;

- (void)drawSelected;

- (void)displayButton;

- (SEL)method;
- (void)setMethod:(SEL)newMethod;

-(void)setNumParams:(int)newValue;
-(int)numParams;



@end
