//
//  City.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>


@interface City : NSObject {
	NSString* name;			// name of the city
	int distanceRoad;		// distance (in turns) by road to city
	int distanceRail;		// distance (in turns) by rail to city
	int distanceCanal;		// distance (in turns) by canal to city
	
	NSPoint positionMap;	// the on screen map location of the city
	
	NSImage* image;		// image the represents the city
	NSPoint positionIconWheel;  // positon on the icon wheel
	
	int price;			// price paid per unit

}

-(void)setName:(NSString*)newName;
-(NSString*)name;

- (void)setPositionMap:(NSPoint)newPosition;
- (NSPoint)positionMap;

-(void)setImage:(NSImage*)newImage;
-(NSImage*)image;

- (void)setPositionIconWheel:(NSPoint)newPosition;
- (NSPoint)positionIconWheel;

- (void)setPrice:(int)newPrice;
- (int)price;

@end
