//
//  Distance.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>

@class City;
@class Factory;

enum {NETWORK_ROAD, NETWORK_RAIL, NETWORK_CANAL };

@interface Distance : NSObject {
	Factory* factory;   // factory going from
	City* city;			// city going to
	int distance[3];	// distance for each type of transport
	NSMutableArray* nodesArrayRoad; // array of nodes that form the route
	NSMutableArray* nodesArrayRail; // array of nodes that form the route
	NSMutableArray* nodesArrayCanal; // array of nodes that form the route
	int built[3];		// distance of each type of transport that has actually been built
	int completed[3];   // has the network been completed for this transport type
	int construction[3];	// are we to carry out construction on this route?
}

- (void)setFactory:(Factory*)newFactory;
- (Factory*)factory;

- (void)setCity:(City*)newCity;
- (City*)city;

- (void)setDistance:(int)newDistance forType:(int)type;
- (int)distance:(int)type;

- (void)setBuilt:(int)newDistance forType:(int)type;
- (int)built:(int)type;

- (void)setCompleted:(BOOL)flag forType:(int)type;
- (BOOL)completed:(int)type;	// has the network been completed for selected type?

- (void)setConstruction:(BOOL)flag forType:(int)type;
- (BOOL)construction:(int)type;

- (void)addNode:(NSPoint)newNode forType:(int)type;
- (int)nodesCount:(int)type;
- (NSPoint)getNodeAtIndex:(int)index forType:(int)type;

- (BOOL)build:(int)type;
@end
