//
//  Factory.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>

enum { FACTORY_COTTON, FACTORY_TIN, FACTORY_POTTERY };

@class Player;

@interface Factory : NSObject {
	NSString* name;			// name of the factory

	int type;		// the type of factory
	int workforceMax;   // the maximum workforce capcity of the factory
	int workforce;   // current workforce level
	int outputRatio;	// the amount of units produced per worker
	int stockMax;		// the maximum amount of completed units that can be kept at the factory
	int stock;   // current stock level
	int runningCost;	// cost per turn of running the factory
	int value;			// the value of the factory
	int sizeMax;		// maximum size of the factory
	int size;	// current size of the factory
	int turnsToBuild;   // number of turns remaining until factory is built
	Player* owner;		// owner of the factory
	
	NSPoint positionMap;	// the on screen map location of the city
	
	NSImage* image;		// image the represents the factory
	NSPoint positionIconWheel;  // positon on the icon wheel


}

- (void)setType:(int)newType;
- (int)type;
- (NSString*)typeAsText;

- (void)setWorkforceMax:(int)newMax;
- (int)workforceMax;

- (void)setWorkforce:(int)newCurrent;
- (int)workforce;
- (BOOL)changeWorkforce:(int)change;

- (void)setOutputRatio:(int)newRatio;
- (int)outputRatio;

- (void)setStockMax:(int)newMax;
- (int)stockMax;

- (void)setStock:(int)newStock;
- (int)stock;
- (BOOL)changeStock:(int)change;

- (void)setRunningCost:(int)newCost;
- (int)runningCost;
- (BOOL)changeRunngingCost:(int)change;

- (void)setValue:(int)newValue;
- (int)value;
- (BOOL)changeValue:(int)change;

- (void)setMaxSize:(int)newSize;
- (int)sizeMax;

- (void)setSize:(int)newSize;
- (int)size;
- (BOOL)changeSize:(int)change;

- (void)setTurnsToBuild:(int)newTurns;
- (int)turnsToBuild;
- (void)changeTurnsToBuild:(int)change;

- (NSString*)description;

- (void)setPositionMap:(NSPoint)newPosition;
- (NSPoint)positionMap;

-(void)setName:(NSString*)newName;
-(NSString*)name;

-(void)setOwner:(Player*)newOwner;
-(Player*)owner;

-(void)setImage:(NSImage*)newImage;
-(NSImage*)image;

- (void)setPositionIconWheel:(NSPoint)newPosition;
- (NSPoint)positionIconWheel;

@end
