//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#import "IRController.h"
#import "IRGame.h"
#import "IRGameView.h"

@implementation IRController

- (void) awakeFromNib
{
	[game setState:STATE_TITLE];
	
	[view setTrackingAreas];
	[view setNeedsDisplay:YES];
	
	
	/* retrieve our movie file from our bundle resource */
    //NSString *filePath = [[NSBundle mainBundle] pathForResource:@"Industrial Game 2004-11-08-" ofType:@"m4a"];
    //NSURL *movieUrl = [NSURL fileURLWithPath:filePath];
	
    /* create an NSMovie object from our QuickTime movie */
    //NSMovie *song2 = [[NSMovie alloc] initWithURL:movieUrl byReference:YES];
	
	/*
    [musicPlayer setMovie:song2];
	
    [musicPlayer gotoBeginning:self];
	[musicPlayer setLoopMode:NSQTMovieLoopingPlayback];
	[musicPlayer start:self];
	 */
		
	/*
    if([game isMusicOn])
    {
        [musicPlayer start:self];
    }
    else
    {
        [musicPlayer stop:self];
    }
	 */
	
}

- (IBAction)checkForNewVersion:(id)sender
{
    NSString *currVersionNumber = [[[NSBundle bundleForClass:[self class]]
        infoDictionary] objectForKey:@"CFBundleVersion"];
	
    NSDictionary *productVersionDict = [NSDictionary dictionaryWithContentsOfURL:
        [NSURL URLWithString:@"http://www.cloisterroom.com/versionlistIR.xml"]];
	
    NSString *latestVersionNumber = [productVersionDict valueForKey:@"IndustrialRevolution"];
    NSString *updateLocation = [productVersionDict valueForKey:@"LocationIndustrialRevolution"];
	
	if(latestVersionNumber == nil)
	{
		NSRunAlertPanel(@"Cannot Connect to Server",
                        @"Cannot connect to the server to check for latest version of Industrial Revolution.",
                        @"OK", nil, nil);
		
	}
    else if([latestVersionNumber isEqualToString: currVersionNumber])
    {
        NSRunAlertPanel(@"Industrial Revolution is up-to-date",
                        @"You have the most recent version of Industrial Revolution.",
                        @"OK", nil, nil);
    }
    else
    {
        int button = NSRunAlertPanel(@"A New Version is Available",
                                     [NSString stringWithFormat:@"A new version of Industrial Revolution is available (version %@). Would you like to download the new version now?", latestVersionNumber], @"OK", @"Cancel", nil);
		
        if(NSOKButton == button)
        {
            [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:updateLocation]];
        }        
    }
}

- (IBAction)toggleMusic:(id)sender
{
	/*
	if(![musicOn state])
    {
        [musicPlayer start:self];
		
		[musicOn setState:YES];
    }
    else
    {
        [musicPlayer stop:self];
		
		[musicOn setState:NO];
    }
	 */
}

@end
