//
//  Invention.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>

#import "Player.h"

@interface Invention : NSObject {
	int turnsToComplete;	// number of turns remaining until inventing has completed
	NSString* name;			// name of the invention
	BOOL invented;			// has the invention been invented
	BOOL invent;			// are we to carry out research to invent this?
	int requiresTech[TECH_COUNT];		// min tech level required
	NSString* details;		// text description of the invention
	
	NSMutableArray* requiresArray;	// array of inventions required
}


-(void)setTurnsToComplete:(int)newValue;
-(int)turnsToComplete;
-(BOOL)changeTurnsToComplete:(int)delta;

-(void)setName:(NSString*)newName;
-(NSString*)name;

-(void)setInvented:(BOOL)state;
-(BOOL)invented;

-(void)setInvent:(BOOL)state;
-(BOOL)invent;

-(void)setRequiresTech:(int)type level:(int)newLevel;
-(int)requiresTech:(int)type;

-(void)setDetails:(NSString*)newDetails;
-(NSString*)details;

-(void)addRequirement:(NSString*)newRequirement;
-(int)requirementCount;
-(NSString*)getRequirementAtIndex:(int)index;

@end
