//
//  Invention.m
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import "Invention.h"


@implementation Invention

- (id) init
{
	int loop;
	
	self = [super init];
	
	[self setInvented:NO];
	[self setInvent:NO];
	
	for(loop = 0; loop < TECH_COUNT; loop++)
	{
		[self setRequiresTech:loop
						level:0];
	}
	
	
	requiresArray = [[NSMutableArray alloc] initWithCapacity:0];

    return self;
}


-(void)setTurnsToComplete:(int)newValue
{
	turnsToComplete = newValue;
}

-(int)turnsToComplete
{
	return turnsToComplete;
}

// return YES when completed
-(BOOL)changeTurnsToComplete:(int)delta
{
	turnsToComplete += delta;
	
	if(turnsToComplete == 0)
	{
		[self setInvented:YES];
		return YES;
	}
	
	return NO;
}

- (void)setName:(NSString*)newName
{
	id old = name;
	name = [newName retain];
	[old release];	
}

- (NSString*)name
{
	return name;
}

-(void)setInvented:(BOOL)state
{
	invented = state;
}

-(BOOL)invented
{
	return invented;
}

-(void)setInvent:(BOOL)state
{
	invent = state;
}

-(BOOL)invent
{
	return invent;
}

-(void)setRequiresTech:(int)type level:(int)newLevel
{
	requiresTech[type] = newLevel;
}

-(int)requiresTech:(int)type
{
	return requiresTech[type];
}


- (void)setDetails:(NSString*)newDetails
{
	id old = details;
	details = [newDetails retain];
	[old release];	
}

- (NSString*)details
{
	return details;
}

-(void)addRequirement:(NSString*)newRequirement
{
	[requiresArray addObject:newRequirement];}

-(int)requirementCount
{
	[requiresArray count];
}

-(NSString*)getRequirementAtIndex:(int)index
{
	return [requiresArray objectAtIndex:index];
}

@end
