//
//  ShopItem.h
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>

#import "Player.h"



@interface ShopItem : NSObject {
	
	NSString* title;	// title of the item
	NSString* details;  // details about the item
	int cost;			// cost of the item
	int turns;			// turns until player gets the item after purchase
	int requiresTech[TECH_COUNT];		// min tech level required
	SEL process;			// what do we do when this item is bought?
	id param1;			// first param for processing

}

-(void)setCost:(int)newCost;
-(int)cost;

-(void)setTurns:(int)newTurns;
-(int)turns;

-(void)setRequiresTech:(int)type level:(int)newLevel;
-(int)requiresTech:(int)type;

-(void)setTitle:(NSString*)newTitle;
-(NSString*)title;

-(void)setDetails:(NSString*)newDetails;
-(NSString*)details;

- (SEL)process;
- (void)setProcess:(SEL)newProcess;

- (void)setParam1:(id)newParam;
- (id)param1;

@end
