//
//  ShopItem.m
//  Industrial Revolution - a turn based business game.
//
//  Created by Andrew on 24/10/2004.
//  Copyright (C) 2004 Andrew Sage. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public
//  License as published by  the Free Software Foundation; either version 2 of the License.
//
//  This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the implied
//  warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License  along with this program; if not, write to the
//  Free Software  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import "ShopItem.h"


@implementation ShopItem


- (id) init
{
	int loop;
	
	self = [super init];
	
	for(loop = 0; loop < TECH_COUNT; loop++)
	{
		[self setRequiresTech:loop
						level:0];
	}
	
    return self;
}




-(void)setCost:(int)newCost
{
	cost = newCost;
}

-(int)cost
{
	return cost;
}

-(void)setTurns:(int)newTurns
{
	turns = newTurns;
}

-(int)turns
{
	return turns;
}

-(void)setRequiresTech:(int)type level:(int)newLevel
{
	requiresTech[type] = newLevel;
}

-(int)requiresTech:(int)type
{
	return requiresTech[type];
}


- (void)setTitle:(NSString*)newTitle
{
	id old = title;
	title = [newTitle retain];
	[old release];	
}

- (NSString*)title
{
	return title;
}

- (void)setDetails:(NSString*)newDetails
{
	id old = details;
	details = [newDetails retain];
	[old release];	
}

- (NSString*)details
{
	return details;
}

- (SEL)process
{
	return process;
}

- (void)setProcess:(SEL)newProcess
{
	process = newProcess;
}


- (void)setParam1:(id)newParam
{
	id old = param1;
	param1 = [newParam retain];
	[old release];
}

- (id)param1
{
	return param1;
}


@end
